#ifndef __RAW2NEF_H
#define __RAW2NEF_H
//

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;
typedef unsigned short color_t;


class TBuff
{
public:
   TBuff() : p(NULL) {}
   TBuff(unsigned sz) : p(new color_t[sz]) {}
   ~TBuff() { delete [] p; }

   color_t* p;
   operator color_t* () { return p; }
   color_t& operator [] (int i) { return p[i]; }

   bool alloc(unsigned sz) { delete [] p; return NULL != (p = new color_t[sz]); }
   void free() { delete [] p; p = NULL; }
};

struct TCCDParam
{
   unsigned raw_width;
   unsigned raw_height;
   unsigned file_size;

   char cfa_pattern[4];

   unsigned row_length;
   unsigned bits_per_sample;
   unsigned camera;

   enum
   {
      fInterlaced = 0x00000001,
      fPrimaryColors = 0x00000002,
   };

   unsigned flags;

   bool (*confirm)(TCCDParam*, FILE*);
};

bool read_raw(FILE* in, color_t ccd[], TCCDParam& ccd_pars);


#ifndef __TIFF_H
#include "tiff.h"
#endif

class NEF_IFD
{
public:
   IFDir IFD0;
   IFDir EXIF;
   IFDir MakerNote;
   IFDir IFD;

   bool read_exif(FILE*);
   bool write_nef(FILE*, bool, color_t[], TCCDParam&, bool=false);
};

#endif
