#include <stdio.h>
#include <string.h>
#pragma hdrstop

#define STRICT
#include <windows.h>

#include "file.h"

#ifdef _MSC_VER

#include <stdlib.h> // __argc, __argv

#else//_MSC_VER

#include <dos.h> // _argc, _argv
#define __argv _argv
#define __argc _argc

#endif//_MSC_VER

const char* program = "raw2nef";

int error(const char* mess)
{
   MessageBox(NULL, mess, program, MB_ICONSTOP|MB_OK);
   return 0;
}

bool raw_to_nef(int n, char* a[]);

class TTempFile
{
   const char* fn;
public:
   TTempFile(const char* _fn) : fn(_fn) {}
   ~TTempFile() { if(fn && fn[0]) DeleteFile(fn); }
};

int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int )
{
   char temp[MAX_PATH];
   char out[MAX_PATH];

   if( !GetTempPath(sizeof temp, temp ) )
      { return error( "Cannot get temporary folder" ); }

   if( !GetTempFileName(temp, "NEF", 0, out) )
      { return error( "Cannot get temporary file" ); }

   if( !freopen(out, "wt", stdout) )
      { return error( "Cannot redirect stdout" ); }

   raw_to_nef(__argc, __argv);

   freopen("nul", "wt", stdout);

   TTempFile temp_file( out );
   TFile in = fopen(out, "rb");
   if( !in )
      return error( "Cannot open message file" );

   fseek( in, 0, SEEK_END );
   int len = ftell( in );
   if( len != 0 )
   {
      fseek( in, 0, SEEK_SET );
      char* mess = new char[len+1];

      if( !mess )
         return error( "Cannot show messages" );

      fread( mess, len, 1, in );
      mess[len] = '\0';

      int flags = MB_OK;
      if( strstr(mess, "error") )
         flags |= MB_ICONERROR;
      else
      if( strstr(mess, "warning") )
         flags |= MB_ICONWARNING;
      else
         flags |= MB_ICONINFORMATION;

      MessageBox(NULL, mess, program, flags);
   }
   return 1;
}

